SystemOrganization addCategory: #'GT-Metaceller-Model'!

MetacelloPlatform subclass: #GTMetacelloPlatform
	instanceVariableNames: 'originalPlatform platformDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacelloPlatform class methodsFor: 'private' stamp: 'DiegoLont 9/16/2013 11:51'!
defaultPlatformDescription
	(self current isKindOf: self) ifFalse: [ self initialize ].
	^self current platformDescription! !

!GTMetacelloPlatform class methodsFor: 'private' stamp: 'DiegoLont 9/16/2013 11:51'!
defaultPlatformDescription: aGTPlatformDescription 
	(self current isKindOf: self) ifFalse: [ self initialize ].
	^self current platformDescription: aGTPlatformDescription ! !

!GTMetacelloPlatform class methodsFor: 'initialization' stamp: 'DiegoLont 9/14/2013 14:50'!
initialize
	"
	GTMetacelloPlatform initialize
	"
	Current := self on: Current! !

!GTMetacelloPlatform class methodsFor: 'instance creation' stamp: 'DiegoLont 9/14/2013 14:52'!
new
	" this platform should always be created with a default platform "
	^self shouldNotImplement! !

!GTMetacelloPlatform class methodsFor: 'instance creation' stamp: 'DiegoLont 9/14/2013 14:51'!
on: aPlatform
	^self basicNew
		initialize: aPlatform;
		yourself! !

!GTMetacelloPlatform methodsFor: 'utilities' stamp: 'DiegoLont 9/16/2013 11:01'!
authorName
	^self originalPlatform authorName! !

!GTMetacelloPlatform methodsFor: 'utilities' stamp: 'DiegoLont 9/16/2013 11:01'!
authorName: aValue
	^self originalPlatform authorName: aValue! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:01'!
bypassGoferLoadUpdateCategories
	^self originalPlatform bypassGoferLoadUpdateCategories! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:01'!
bypassGoferLoadUpdateCategories: anObject
	^self originalPlatform bypassGoferLoadUpdateCategories: anObject! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:01'!
bypassProgressBars
	^self originalPlatform bypassProgressBars! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:02'!
bypassProgressBars: anObject
	^self originalPlatform bypassProgressBars: anObject! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:02'!
clearCurrentVersionCache
	^self originalPlatform clearCurrentVersionCache! !

!GTMetacelloPlatform methodsFor: 'notification' stamp: 'DiegoLont 9/16/2013 11:02'!
collection: aCollection do: aBlock displaying: aString
	^self originalPlatform collection: aCollection do: aBlock displaying: aString! !

!GTMetacelloPlatform methodsFor: 'user interaction' stamp: 'DiegoLont 9/16/2013 11:02'!
confirm: aString
	^self originalPlatform confirm: aString! !

!GTMetacelloPlatform methodsFor: 'reflection' stamp: 'DiegoLont 9/16/2013 11:03'!
copyClass: oldClass as: newName inCategory: newCategoryName
	^self originalPlatform copyClass: oldClass as: newName inCategory: newCategoryName! !

!GTMetacelloPlatform methodsFor: 'repository creation' stamp: 'DiegoLont 9/16/2013 11:03'!
createRepository: aRepositorySpec
	^self originalPlatform createRepository: aRepositorySpec! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:50'!
defaultPlatformAttributes
	self platformDescription ifNil: [ ^self originalPlatform defaultPlatformAttributes ].
	^self platformDescription attributes! !

!GTMetacelloPlatform methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 11:04'!
defaultTimeout
	^self originalPlatform defaultTimeout! !

!GTMetacelloPlatform methodsFor: 'notification' stamp: 'DiegoLont 9/16/2013 11:03'!
do: aBlock displaying: aString
	^self originalPlatform do: aBlock displaying: aString! !

!GTMetacelloPlatform methodsFor: 'repository creation' stamp: 'DiegoLont 9/16/2013 11:04'!
extractTypeFromDescription: description

	^self originalPlatform extractTypeFromDescription: description
! !

!GTMetacelloPlatform methodsFor: 'reflection' stamp: 'DiegoLont 9/16/2013 11:04'!
globalNamed: globalName

	^self originalPlatform globalNamed: globalName! !

!GTMetacelloPlatform methodsFor: 'reflection' stamp: 'DiegoLont 9/16/2013 11:04'!
globalNamed: globalName ifAbsent: absentBlock

	^self originalPlatform globalNamed: globalName ifAbsent: absentBlock! !

!GTMetacelloPlatform methodsFor: 'initialization' stamp: 'DiegoLont 9/14/2013 15:14'!
initialize: aPlatform
	self initialize.
	originalPlatform := aPlatform! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/14/2013 15:18'!
originalPlatform
	^originalPlatform! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:50'!
platformDescription
	^platformDescription! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:51'!
platformDescription: aGTPlatformDescription 
	platformDescription := aGTPlatformDescription! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:04'!
primeStackCacheFor: cacheName doing: noArgBlock defaultDictionary: aDictionary
	^self originalPlatform primeStackCacheFor: cacheName doing: noArgBlock defaultDictionary: aDictionary! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:04'!
primeStackCacheWith: aDictionary doing: noArgBlock
	^self originalPlatform primeStackCacheWith: aDictionary doing: noArgBlock! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:05'!
stackCacheFor: cacheName at: key doing: aBlock
	^self originalPlatform stackCacheFor: cacheName at: key doing: aBlock! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:05'!
stackCacheFor: cacheName cacheClass: cacheClass at: key doing: aBlock

	^self originalPlatform stackCacheFor: cacheName cacheClass: cacheClass at: key doing: aBlock
! !

!GTMetacelloPlatform methodsFor: 'utilities' stamp: 'DiegoLont 9/16/2013 11:05'!
timestamp

	^self originalPlatform timestamp! !

!GTMetacelloPlatform methodsFor: 'transactions' stamp: 'DiegoLont 9/16/2013 11:05'!
transact: aBlock

	^self originalPlatform transact: aBlock! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:05'!
useStackCacheDuring: aBlock defaultDictionary: defaultDictionary
	^self originalPlatform useStackCacheDuring: aBlock defaultDictionary: defaultDictionary! !

!MetacelloPackageSpec methodsFor: '*GT-Metaceller-Model' stamp: 'TudorGirba 4/1/2013 09:16'!
hasNewerVersionsFrom: version
	| g |
	g := Gofer new.
	version spec repositories list do: [:each | g url: each name ].
	g package: self name.
	^ g resolved first name ~= self currentVersionInfo name! !

!MetacelloPackageSpec methodsFor: '*GT-Metaceller-Model' stamp: 'TudorGirba 4/1/2013 09:07'!
needsSaving
	| copy |
	copy := self workingCopy.
	copy isNil ifTrue: [^ false ].
	^ copy needsSaving! !

Object subclass: #GTMetacellerConfiguration
	instanceVariableNames: 'configuration mainProject projects platformSymbols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerConfiguration class methodsFor: 'instance creation' stamp: 'DiegoLont 9/13/2013 09:27'!
on: aConfiguration
	^self basicNew
		initialize: aConfiguration;
		yourself! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:13'!
children
	^self mainProject childConfigurations collect: [ :each | GTMetacellerConfiguration on: each ]! !

!GTMetacellerConfiguration methodsFor: 'accessor' stamp: 'DiegoLont 9/13/2013 09:28'!
configuration
	^configuration! !

!GTMetacellerConfiguration methodsFor: 'accessor' stamp: 'DiegoLont 9/13/2013 10:07'!
displayString
	^self shortName! !

!GTMetacellerConfiguration methodsFor: 'initialization' stamp: 'DiegoLont 9/13/2013 09:27'!
initialize: aConfiguration
	self initialize.
	configuration := aConfiguration! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:18'!
mainMethods
	^self mainProject allMethods ! !

!GTMetacellerConfiguration methodsFor: 'accessor' stamp: 'DiegoLont 9/16/2013 13:26'!
mainProject
	^mainProject ifNil: [ mainProject := GTMetacellerMainProject on: self configuration ]! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:17'!
mainVersions
	^self mainProject versions! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:05'!
projects
	^self mainProject projects! !

!GTMetacellerConfiguration methodsFor: 'private' stamp: 'DiegoLont 10/8/2013 10:53'!
reset
	mainProject := nil.
	projects := nil.
	platformSymbols := nil! !

!GTMetacellerConfiguration methodsFor: 'display' stamp: 'DiegoLont 9/13/2013 10:07'!
shortName
	^ ((self configuration name beginsWith: 'ConfigurationOf') 
		ifTrue: [self configuration name copyFrom: 'ConfigurationOf' size + 1 to: self configuration name size ] 
		ifFalse: [self configuration name]) asString! !

!GTMetacellerConfiguration methodsFor: 'roassal' stamp: 'DiegoLont 9/13/2013 11:36'!
viewVersionMapOn: view
	self mainProject viewVersionMapOn: view! !

Object subclass: #GTMetacellerItem
	instanceVariableNames: 'version referenceSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTMetacellerItem subclass: #GTMetacellerGroup
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 10/8/2013 10:25'!
buildChildren
	| retVal |
	retVal := OrderedCollection new.
	self addAll: self group name to: retVal version: self version.
	^retVal collect: [ :each | self wrapperFor: each version: self version ]
! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 13:14'!
children
	^children ifNil: [ children := self buildChildren ]! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 12:05'!
file
	^self group file! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:49'!
group
	^self referenceSpec! !

!GTMetacellerGroup methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isGroup
	^true! !

!GTMetacellerGroup methodsFor: 'testing' stamp: 'DiegoLont 4/22/2013 12:06'!
isPackageLoaded
	^self group isPackageLoaded! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 12:09'!
label
	^self group label! !

!GTMetacellerGroup methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 14:10'!
labelAsText
	^Text string: self label attribute: TextEmphasis italic! !

!GTMetacellerItem class methodsFor: 'instance creation' stamp: 'DiegoLont 4/24/2013 14:50'!
on: aVersion spec: aSpec
	^self basicNew
		initialize: aVersion spec: aSpec;
		yourself! !

!GTMetacellerItem methodsFor: 'building' stamp: 'DiegoLont 10/8/2013 10:25'!
addAll: aString to: aCollection version: aVersion
	| spec |
	spec := aVersion packageNamed: aString ifAbsent: [ nil ].
	(aCollection includes: spec) ifTrue: [ ^self ].
	(self isProject: spec) ifFalse: [ spec requires do: [ :each | self addAll: each to: aCollection version: aVersion ] ].
	(self isGroup: spec) ifFalse: [ aCollection add: spec ].
	(self isProject: spec) ifFalse: [ spec includes do: [ :each | self addAll: each to: aCollection version: aVersion ] ]! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:53'!
asString
	^self referenceSpec asString ! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 15:36'!
children
	^#()! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 13:32'!
hasName: aString 
	^self name = aString! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 14:37'!
hasPlatform: aSymbol 
	^self platforms contains: [ :each | each hasSymbol: aSymbol ]! !

!GTMetacellerItem methodsFor: 'initialization' stamp: 'DiegoLont 4/24/2013 14:29'!
initialize: aVersion
	self initialize.
	version := aVersion! !

!GTMetacellerItem methodsFor: 'initialization' stamp: 'DiegoLont 4/24/2013 14:49'!
initialize: aVersion spec: aSpec
	self initialize.
	version := aVersion.
	referenceSpec := aSpec! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isGroup
	^false! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:38'!
isGroup: aSpec 
	^aSpec isKindOf: MetacelloGroupSpec! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isPackage
	^false! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:37'!
isPackage: aSpec 
	^aSpec isKindOf: MetacelloPackageSpec! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isProject
	^false! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:38'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ aSpec isKindOf: MetacelloProjectSpec ]! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 15:36'!
labelAsText
	^self referenceSpec label! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:52'!
name
	^self referenceSpec name! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:46'!
platforms
	^self version platformsFor: self! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:49'!
referenceSpec
	^referenceSpec! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:30'!
version
	^version! !

!GTMetacellerItem methodsFor: 'tool' stamp: 'DiegoLont 4/25/2013 09:17'!
wrapperFor: aSpec version: aVersion
	(self isProject: aSpec) ifTrue: [  ^GTMetacellerProjectReference on: aVersion spec: aSpec ].
	(self isGroup: aSpec) ifTrue: [  ^GTMetacellerGroup on: aVersion spec: aSpec ].
	(self isPackage: aSpec) ifTrue: [ ^GTMetacellerPackage on: aVersion spec: aSpec ].
	^aSpec! !

GTMetacellerItem subclass: #GTMetacellerPackage
	instanceVariableNames: 'isNewer isOlder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:51'!
calculateIsNewer
	(self file = self referenceSpec name) ifTrue: [  ^false ].
	(self referenceSpec currentVersionInfo name = self file) ifTrue: [ ^false ].
	self referenceSpec currentVersionInfo allAncestorsDo: [ :each |
		(each name = self file) ifTrue: [ ^false ] ].
	^true! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:51'!
calculateIsOlder
	(self file = self referenceSpec name) ifTrue: [  ^false ].	" no version specified "
	(self referenceSpec currentVersionInfo name = self file) ifTrue: [ ^false ].
	self referenceSpec currentVersionInfo allAncestorsDo: [ :each |
		(each name = self file) ifTrue: [ ^true ] ].
	^false! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 09:10'!
file
	^self packageSpec file! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 4/25/2013 09:23'!
isLoaded
	^self packageSpec isPackageLoaded! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:51'!
isNewer
	^isNewer ifNil: [ isNewer := self calculateIsNewer ]! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:51'!
isOlder
	^isOlder ifNil: [ isOlder := self calculateIsOlder ]! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isPackage
	^true! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 13:50'!
label
	^self file ifEmpty: [ self packageSpec name ]! !

!GTMetacellerPackage methodsFor: 'display' stamp: 'DiegoLont 9/13/2013 13:49'!
labelAsText
	| prefix |
	prefix := ''.
	self needsSaving ifTrue: [ prefix := '* ' ].
	^(Text fromString: prefix), (Text string: self label attributes: self textAttributes)! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:44'!
loadedVersionName
	self referenceSpec workingCopy ifNotNil: [
		^self referenceSpec workingCopy ancestry ancestorString ].
	^self referenceSpec file! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 4/25/2013 09:15'!
needsSaving
	self packageSpec workingCopy ifNotNilDo: [ :copy | ^copy needsSaving ].
	^false! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 09:09'!
packageSpec
	^self referenceSpec! !

!GTMetacellerPackage methodsFor: 'printing' stamp: 'DiegoLont 9/16/2013 14:40'!
printVersionOn: aStream 
	aStream nextPutAll: 'package: '''; nextPutAll: self name; nextPutAll: ''' with: '''; nextPutAll: self loadedVersionName; nextPutAll: ''''! !

!GTMetacellerPackage methodsFor: 'display' stamp: 'DiegoLont 4/25/2013 11:45'!
textAttributes
	| retVal |
	retVal := OrderedCollection new.
	self isLoaded ifTrue: [ 
		retVal add: TextEmphasis underlined.
		self isNewer ifTrue: [ retVal add: TextEmphasis bold ].
		self isOlder ifTrue: [  retVal add: TextColor gray ] ].
	^retVal! !

GTMetacellerItem subclass: #GTMetacellerProjectReference
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 10/7/2013 14:24'!
buildChildren
	" here we return the 'labels' referenced by this project "
	| projectVersion |
	self isLoaded ifFalse: [ ^#() ].
	projectVersion := self projectReference versionOrNil.
	projectVersion ifNil: [  ^#() ].
	(self projectReference loads) ifNil: [ ^projectVersion spec packages packageSpecsInLoadOrder
		collect: [ :each | self wrapperFor: each version: projectVersion ] ].
	" here we need to resolve what loads means ... since metacello does not have an easy way to determin this. "
	^self calculateProjectReferences
	! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 10/8/2013 10:27'!
calculateProjectReferences
	" calculate all packages and such from the referred project "
	| projectVersion retVal |
	projectVersion := self projectReference versionOrNil.
	retVal := OrderedCollection new.
	self projectReference loads do: [ :each |
		self addAll: each to: retVal version: projectVersion ].
	^retVal collect: [ :each | self wrapperFor: each version: projectVersion ]! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 10/7/2013 14:25'!
children
	" here we return the 'labels' referenced by this project "
	^children ifNil: [ children := self buildChildren ]! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:22'!
configForProject
	| projectReference |
	projectReference := self projectReference.
	projectReference ifNil: [  ^nil ].
	projectReference className ifNil: [  ^nil ].
	^Smalltalk at: (projectReference className asSymbol) ifAbsent: [ nil ]! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 13:58'!
file
	^self project file! !

!GTMetacellerProjectReference methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:55'!
isLoaded
	^self configForProject notNil! !

!GTMetacellerProjectReference methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isProject
	^true! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:06'!
label
	^self project label! !

!GTMetacellerProjectReference methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 14:06'!
labelAsText
	| attributes |
	attributes := OrderedCollection new.
	(self isLoaded) ifTrue: [ attributes add: TextEmphasis underlined ].
	attributes add: TextColor blue.
	self versionString 
		ifNil: [ ^(Text string: self  label attributes: attributes), (Text string: ' No version' attribute: TextColor red) ]
		ifNotNil: [ ^(Text string: self label attributes: attributes), (Text string: (' ', self versionString) attribute: TextColor blue) ].
	! !

!GTMetacellerProjectReference methodsFor: 'printing' stamp: 'DiegoLont 9/17/2013 13:09'!
printVersionOn: aStream
	| configClass |
	self referenceSpec projectReference className
		ifNil: [ configClass := nil. ]
		ifNotNil: [ configClass := Smalltalk at: self referenceSpec projectReference className asSymbol ifAbsent: [ nil ] ].
	aStream nextPutAll: 'project: '''; nextPutAll: self name; nextPutAll: ''' with: '.
	configClass
		ifNil: [ aStream nextPutAll: self referenceSpec projectReference versionString printString ]
		ifNotNil: [ aStream nextPut: $';
			nextPutAll: (configClass project version: self referenceSpec projectReference versionString) versionNumber printString;
			nextPut: $' ]! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:50'!
project
	^self referenceSpec! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:22'!
projectReference
	self project ifNil: [  ^nil ].
	(self project isKindOf: MetacelloProjectReferenceSpec)
		ifTrue: [ ^self project projectReference ]
		ifFalse: [ ^self project ]! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:03'!
versionString
	^self project versionString! !

Object subclass: #GTMetacellerProject
	instanceVariableNames: 'configuration project stableVersion bleedingEdge development currentVersion versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTMetacellerProject subclass: #GTMetacellerAtributedProject
	instanceVariableNames: 'platformDescription mainProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerAtributedProject class methodsFor: 'instance creation' stamp: 'DiegoLont 9/17/2013 09:30'!
on: aConfigurationClass main: aMainProject platform: aPlatformDescription
	^self basicNew
		initialize: aConfigurationClass main: aMainProject platform: aPlatformDescription;
		yourself! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:23'!
displayString
	^self platformDescription symbol asString! !

!GTMetacellerAtributedProject methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 11:54'!
hasAttributes
	^true! !

!GTMetacellerAtributedProject methodsFor: 'testing' stamp: 'DiegoLont 9/17/2013 09:25'!
hasPlatform: aPlatform
	^self platformDescription hasSymbol: aPlatform! !

!GTMetacellerAtributedProject methodsFor: 'initialization' stamp: 'DiegoLont 9/17/2013 09:30'!
initialize: aConfigurationClass main: aMainProject platform: aPlatformDescription
	self initialize: aConfigurationClass.
	mainProject := aMainProject.
	platformDescription := aPlatformDescription! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 13:19'!
itemsFor: aPlatform in: aVersion 
	^(self version: aVersion) items select: [ :each | (each hasPlatform: aPlatform) and: [ each isGroup not ] ]! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:30'!
mainProject
	^mainProject! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:44'!
platformDescription
	^ platformDescription! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:29'!
platformsFor: anItem version: aVersion 
	^self mainProject platformsFor: anItem version: aVersion! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:45'!
project
	^project ifNil: [ 
		GTMetacelloPlatform defaultPlatformDescription: self platformDescription.
		[ project := configuration project ] ensure: [ GTMetacelloPlatform defaultPlatformDescription: nil ] ]! !

GTMetacellerProject subclass: #GTMetacellerMainProject
	instanceVariableNames: 'platformSymbols projects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerMainProject methodsFor: 'initialization' stamp: 'DiegoLont 9/16/2013 13:23'!
addPlatformSymbolsTo: aSet versionSpec: aSpec pragma: aPragma in: aConstructor
	aConstructor evaluatePragma: aPragma.
	aSet addAll: aConstructor attributeMap keys
! !

!GTMetacellerMainProject methodsFor: 'initialization' stamp: 'DiegoLont 9/17/2013 09:30'!
buildProjects
	^self platformSymbols collect: [ :each |
		GTMetacellerAtributedProject on: self configuration main: self platform: (GTPlatformDescription onSymbol: each) ]! !

!GTMetacellerMainProject methodsFor: 'initialization' stamp: 'DiegoLont 9/16/2013 13:23'!
createPlatformSymbols
	| retVal constructor versionMap symbolicVersionMap executionBlock |
	retVal := Set new.
	constructor := MetacelloVersionConstructor new
		configuration: self configuration new;
		yourself.
	versionMap := Dictionary new.
	symbolicVersionMap := Dictionary new.
	executionBlock := [ :versionSpec :pragma | self addPlatformSymbolsTo: retVal versionSpec: versionSpec pragma: pragma in: constructor ].
	constructor collectAllVersionsFromVersionPragmasInto: versionMap using: executionBlock.
	constructor
		collectAllVersionsFromVersionImportPragmasInto: versionMap
		using: executionBlock
		satisfiedPragmas: (constructor versionImportPragmasVerifiedDefinedIn: versionMap).
	constructor collectAllSymbolicVersionsFromVersionPragmasInto: symbolicVersionMap using: executionBlock.
	^retVal
! !

!GTMetacellerMainProject methodsFor: 'actions' stamp: 'DiegoLont 9/17/2013 13:21'!
createSnapshotVersion: aString baseline: aBaseline
	(self version: aString) ifNotNil: [ 
		" do not create a version that exists already, perhalps an error is more appropriate "
		^self ].
	self configuration compile: (self snapshotVersion: aString baseline: aBaseline)
		classified: 'versions'! !

!GTMetacellerMainProject methodsFor: 'testing' stamp: 'DiegoLont 9/17/2013 09:21'!
hasPlatform: aPlatform
	(#common compare: aPlatform caseSensitive: false) = 2 ifTrue: [ ^true ].
	^MetacelloPlatform current defaultPlatformAttributes contains: [ :each |
		(each compare: aPlatform caseSensitive: false) = 2 ]! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 13:19'!
itemsFor: aPlatform in: aVersion 
	(self hasPlatform: aPlatform)
		ifTrue: [ ^((self version: aVersion) items
			select: [ :each | (each hasPlatform: aPlatform) and: [ each isGroup not ] ]) ].
	^(self projectFor: aPlatform) itemsFor: aPlatform in: aVersion ! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:55'!
normalizePlatforms: aSet
	| retVal |
	retVal := Set new.
	aSet do: [ :newItem | 
		(aSet contains: [ :each | each isParent: newItem])
			ifFalse: [ retVal add: newItem ] ].
	^retVal! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:24'!
platformSymbols
	^platformSymbols ifNil: [ platformSymbols := self createPlatformSymbols ]! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:47'!
platformsFor: aMetacellerItem version: aVersionName
	| platforms |
	platforms := Set new.
	self projects do: [ :each |
		(each hasItem: aMetacellerItem inVersion: aVersionName) ifTrue: [ 
			platforms add: each platformDescription ] ].
	^self normalizePlatforms: platforms! !

!GTMetacellerMainProject methodsFor: 'printing' stamp: 'DiegoLont 9/17/2013 13:19'!
printVersionsFor: aPlatform version: aVersion on: aStream
	| items |
	items := (self itemsFor: aPlatform in: aVersion name).
	items ifNotEmpty: [ 
		| first |
		aStream tab; nextPutAll: 'aSpec for: '.
		aPlatform printOn: aStream.
		aStream nextPutAll: ' do: ['; cr.
		first := true.
		items do: [ :each |
			first 
				ifTrue: [ aStream tab; tab; nextPutAll: 'aSpec '.
					first := false ]
				ifFalse: [ aStream nextPut: $;; cr; tab; tab; tab ].
			each printVersionOn: aStream ].
		aStream nextPutAll: '].'; cr ]! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:24'!
projectFor: aPlatform
	^self projects detect: [ :each | each hasPlatform: aPlatform ]! !

!GTMetacellerMainProject methodsFor: 'dummy' stamp: 'DiegoLont 9/16/2013 13:25'!
projects
	^projects ifNil: [ projects := self buildProjects ]! !

!GTMetacellerMainProject methodsFor: 'printing' stamp: 'DiegoLont 9/17/2013 09:20'!
snapshotVersion: aString baseline: aBaseline
	| version |
	" this method needs a baseline "
	version := self version: aBaseline.
	version ifNil: [ ^nil ].
	^String streamContents: [ :s |
		s nextPutAll: (('version', aString) asIdentifier: false); nextPutAll: ': aSpec'; cr;
			tab; nextPutAll: '<version:'''; nextPutAll: aString; nextPutAll: ''' imports: #( ''';nextPutAll: aBaseline; nextPutAll: ''' )>'; cr;
			cr.
		self platformSymbols do: [ :platform |
			self printVersionsFor: platform version: version on: s ] ]! !

!GTMetacellerProject class methodsFor: 'instance creation' stamp: 'DiegoLont 4/17/2013 16:30'!
on: aConfiguration
	^self basicNew
		initialize: aConfiguration;
		yourself! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 11:38'!
allMethods
	^GTMetacellerVersion allMethodsForProject: self! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/26/2013 16:25'!
bleedingEdge
	bleedingEdge ifNil: [
		[ bleedingEdge := self project bleedingEdge ] on: MetacelloVersionDoesNotExistError ].
	^bleedingEdge! !

!GTMetacellerProject methodsFor: 'initialization' stamp: 'DiegoLont 9/17/2013 09:43'!
buildVersions
	^GTMetacellerVersion versionsForProject: self! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 15:24'!
checkCurrentVersion
	currentVersion ifNil: [ currentVersion := self project currentVersion ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:12'!
childConfigurations
	[ ^(self projectsForVersion: self project stableVersion) collect: [ :each | self configForProject: each ] thenSelect: [ :each | each notNil ] ] on: MetacelloSymbolicVersionDoesNotExistError do: [ ^#() ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:09'!
configForProject: aSpec
	| projectReference |
	aSpec ifNil: [  ^nil ].
	(aSpec isKindOf: MetacelloProjectReferenceSpec)
		ifTrue: [ projectReference := aSpec projectReference ]
		ifFalse: [ projectReference := aSpec ].
	projectReference ifNil: [  ^nil ].
	projectReference className ifNil: [  ^nil ].
	^Smalltalk at: (projectReference className asSymbol) ifAbsent: [ nil ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:18'!
configuration
	^ configuration! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 15:22'!
currentVersion
	^ currentVersion! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/26/2013 16:26'!
development
	development ifNil: [ 
		[ development := self project development ] on: MetacelloVersionDoesNotExistError do: [ ] ].
	^development! !

!GTMetacellerProject methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 11:54'!
hasAttributes
	^false! !

!GTMetacellerProject methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 13:49'!
hasItem: aMetacellerItem inVersion: aVersion
	^((self version: aVersion) ifNil: [ ^false ]) hasItem: aMetacellerItem! !

!GTMetacellerProject methodsFor: 'initialization' stamp: 'DiegoLont 4/17/2013 16:30'!
initialize: aConfiguration
	self initialize.
	configuration := aConfiguration! !

!GTMetacellerProject methodsFor: 'testing' stamp: 'DiegoLont 9/13/2013 10:11'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ (aSpec isKindOf: MetacelloProjectSpec) ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:19'!
metacelloVersion: aStringOrSymbol
	self project ifNil: [ ^nil ].
	^self project version: aStringOrSymbol! !

!GTMetacellerProject methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:24'!
methodClass
	^self configuration! !

!GTMetacellerProject methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:23'!
methodString
	^''! !

!GTMetacellerProject methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:24'!
packages
	^#()! !

!GTMetacellerProject methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:23'!
packagesAndProjects
	^#()! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:33'!
project
	^project ifNil: [ project := configuration project ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:11'!
projectsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [ ^#() ].
	^aVersion spec packages packageSpecsInLoadOrder select: [  :each | self isProject: each ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/26/2013 16:26'!
stableVersion
	stableVersion ifNil: [ 
		[ stableVersion := self project stableVersion ] on: MetacelloVersionDoesNotExistError do: [ ] ].
	^stableVersion! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/14/2013 16:51'!
tags
	^#()! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/14/2013 16:51'!
textLabel
	^self displayString! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:13'!
version: aStringOrSymbol
	self project ifNil: [ ^nil ].
	^self versions detect: [ :each | each hasName: aStringOrSymbol ] ifNone: [ nil ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:43'!
versions
	^versions ifNil: [ versions := GTMetacellerVersion versionsForProject: self ]! !

!GTMetacellerProject methodsFor: 'roassal' stamp: 'DiegoLont 9/13/2013 11:36'!
viewVersionMapOn: view
	| nodes edges |
	nodes := Dictionary new.
	edges := OrderedCollection new.
	(Pragma allNamed: #version: in: self configuration) do: [:prag | 
		nodes at: (prag argumentAt: 1) put: (project version: (prag argumentAt: 1)) ].
	(Pragma allNamed: #version:imports: in: self configuration) do: [:prag | 
		| version imported |
		version := nodes at: (prag argumentAt: 1) put: (project version: (prag argumentAt: 1)).
		(prag argumentAt: 2) do: [:eachImportPrag |
			imported := nodes at: eachImportPrag ifAbsentPut: [ project version: eachImportPrag ].
			edges add: version -> imported ] ].
	view shape label text: [ :each | each versionNumber printString ].
	view nodes: nodes values.
	view edges: edges from: #key to: #value.
	view horizontalDominanceTreeLayout! !

Object subclass: #GTMetacellerVersion
	instanceVariableNames: 'method version configuration cachedPackageMap project groups items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerVersion class methodsFor: 'conveniance' stamp: 'DiegoLont 9/13/2013 11:39'!
allMethodsForProject:aProject
	^aProject configuration methods collect: [ :each |
		self on: aProject configuration method: each project: aProject ]! !

!GTMetacellerVersion class methodsFor: 'testing' stamp: 'DiegoLont 4/16/2013 11:27'!
isValidVersion: aVersion
	aVersion pragmas do: [ :each |
		(each key beginsWith: 'version') ifTrue: [  ^true ] ].
	^false! !

!GTMetacellerVersion class methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 11:07'!
load: aString 
	self version ifNotNil: [ self version load: aString ]! !

!GTMetacellerVersion class methodsFor: 'instance creation' stamp: 'DiegoLont 4/17/2013 16:03'!
on: aConfiguration method: aMethod project: aProject
	^self basicNew
		initialize: aConfiguration method: aMethod project: aProject;
		yourself! !

!GTMetacellerVersion class methodsFor: 'conveniance' stamp: 'DiegoLont 9/13/2013 11:40'!
versionsForProject: aProject
	^(aProject configuration methods
		select: [ :each | self isValidVersion: each ]
		thenCollect: [ :each | self on: aProject configuration method: each project: aProject ]) 
			asSortedCollection: [ :a :b | a name > b name ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/25/2013 15:38'!
actions
	| retVal |
	retVal := OrderedCollection new.
	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection inspect ];
			title: 'Inspect'
			yourself).
	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection method browse ];
			title: 'Browse method'
			yourself).
	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection load ];
			title: 'Load'
			yourself).
 	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection fetch ];
			title: 'Fetch'
			yourself).
"
	This checks the current version, but it needs to update the ui without recreating the versions
 	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection checkCurrentVersion ];
			title: 'Check current version'
			yourself).
"	self isDevelopment ifTrue: [ 
	 	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection update ];
			title: 'Update'
			yourself) ].
	^retVal! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:18'!
belongsToGroup: aSpec
	^(self tagsOf: aSpec) notEmpty! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 11:42'!
blessing
	^self version spec blessing value! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:12'!
buildGroups
	self version ifNotNil: [ 
		^self version groups collect: [ :each | GTMetacellerGroup on: self version spec: each ] ].
	^#()! !

!GTMetacellerVersion methodsFor: 'initialization' stamp: 'DiegoLont 9/16/2013 13:31'!
buildItems
	^self packagesAndProjects collect: [ :each | self wrapperFor: each ] ! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/25/2013 15:28'!
checkCurrentVersion
	self project checkCurrentVersion! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
configuration
	^ configuration! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
configuration: anObject
	configuration := anObject! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:15'!
determineVersion
	self project ifNil: [  ^nil ].
	self method pragmas do: [ :each |
		(each key beginsWith: 'version') ifTrue: [ ^self project metacelloVersion: (each arguments first) ] ].
	^nil! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:23'!
displayString
	^self textLabel! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 16:38'!
fetch
	self version ifNotNil: [ self version fetch ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 14:06'!
groups
	^groups ifNil: [ groups := self buildGroups ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 18:37'!
groupsAndLoosePackages
	^(OrderedCollection withAll: self packagesWithoutGroups)
		addAll: self groups;
		yourself! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 13:50'!
hasItem: aMetacellerItem
	^self items contains: [ :each | each name = aMetacellerItem name ]! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 13:13'!
hasName: aString 
	^self name = aString! !

!GTMetacellerVersion methodsFor: 'initialization' stamp: 'DiegoLont 4/17/2013 16:05'!
initialize: aConfiguration method: aMethod project: aProject
	self initialize.
	method := aMethod.
	configuration := aConfiguration.
	project := aProject! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/17/2013 16:16'!
isBleedingEdge
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^false
	"
	This should be this code ... but this is a bit slow
	[ ^(self project bleedingEdge = self version) ] on: MetacelloSymbolicVersionDoesNotExistError do: [ ^false ]."! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 11:44'!
isCurrent
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^self project currentVersion = self version! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/26/2013 15:50'!
isDevelopment
	^self blessing = #development! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/26/2013 15:49'!
isDevelopmentVersion
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^self project development = self version! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/17/2013 13:14'!
isGroup: aSpec 
	^aSpec isKindOf: MetacelloGroupSpec! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 13:57'!
isPackage: aSpec 
	^aSpec isKindOf: MetacelloPackageSpec! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 13:57'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ aSpec isKindOf: MetacelloProjectSpec ]! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/17/2013 16:10'!
isStable
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	[ ^(self project stableVersion = self version) ] on: MetacelloSymbolicVersionDoesNotExistError do: [ ^false ].! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:38'!
items
	^items ifNil: [ items := self buildItems ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 16:26'!
load
	self version ifNotNil: [ self version load ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/25/2013 11:09'!
load: aString 
	self version ifNotNil: [ self version load: aString ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
method
	^ method! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
method: anObject
	method := anObject! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:43'!
methodCategory
	^self method category! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:42'!
methodClass
	^self configuration! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:42'!
methodString
	^self method asString! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/16/2013 09:15'!
name
	method pragmas do: [  :each |
		(each key beginsWith: 'version') ifTrue: [ ^each arguments first ] ].
	^method selector! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:30'!
package: aString
	^self items detect: [ :each | each hasName: aString ] ifNone: [ nil ]
	! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:40'!
packageNamed: aString ifAbsent: aBlock 
	self version ifNil: [ ^nil ].
	^self version packageNamed: aString ifAbsent: aBlock! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:48'!
packages
	self version ifNil: [ ^#() ].
	^self version packages! !

!GTMetacellerVersion methodsFor: 'caching' stamp: 'DiegoLont 4/22/2013 14:08'!
packagesAndGroups
	cachedPackageMap ifNil: [
		cachedPackageMap := Dictionary new.
		self version ifNotNil: [
			self groups do: [:eachGroup |
				eachGroup children do: [ :eachPackage |
					(cachedPackageMap at: eachPackage ifAbsentPut: [OrderedCollection new])
						add: eachGroup name ] ] ] ].
	^ cachedPackageMap! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 13:56'!
packagesAndProjects
	self version ifNil: [ ^#() ].
	^(self version spec packages packageSpecsInLoadOrder)
		collect: [ :each | self wrapperFor: each ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:47'!
packagesForSpecNamed: aVersionString 
	self version ifNotNil: [ ^self version packagesForSpecNamed: aVersionString ].
	^#()! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:22'!
packagesWithoutGroups
	" make sure the groups are built first "
	self groups.
	^self packagesAndProjects select: [ :each | (each isPackage or: [ each isProject ]) and: [ (self belongsToGroup: each) not ] ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:47'!
platformsFor: aMetacellerItem
	^self project platformsFor: aMetacellerItem version: self name! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:07'!
project
	^project! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:48'!
projects
	self version ifNil: [ ^#() ].
	^self version projects! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:38'!
selector
	^self method selector! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:34'!
spec
	self version ifNotNil: [ ^self version spec ].
	^nil! !

!GTMetacellerVersion methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 11:43'!
tags
	self version ifNil: [  ^#() ].
	^Array with: self blessing! !

!GTMetacellerVersion methodsFor: 'display' stamp: 'DiegoLont 9/12/2013 16:10'!
tagsOf: aSpec
	(aSpec isKindOf: GTMetacellerItem) ifTrue: [ ^self tagsOf: aSpec referenceSpec ].
	(aSpec isKindOf: MetacelloProjectReferenceSpec) ifTrue: [  ^self tagsOf: aSpec projectReference ].
	^self packagesAndGroups at: aSpec ifAbsent: [OrderedCollection new]! !

!GTMetacellerVersion methodsFor: 'display' stamp: 'DiegoLont 4/26/2013 15:50'!
textLabel
	| attributes |
	attributes := OrderedCollection new.
	self version ifNil: [ attributes add: TextColor red ].
	self isBleedingEdge ifTrue: [ attributes add: TextColor red  ].
	self isDevelopmentVersion ifTrue: [ attributes add: TextColor blue ].
	self isCurrent ifTrue: [ attributes add: TextEmphasis underlined ].
	self isStable ifTrue: [ attributes add: TextEmphasis bold ].
	^Text string: self name attributes: attributes! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 15:39'!
update
	self isDevelopment ifTrue: [
		MetacelloToolBox updateToLatestPackageVersionsIn: self configuration description: 'Please describe this version.' ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:18'!
version
	^ version ifNil: [ version := self determineVersion ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
version: anObject
	version := anObject! !

!GTMetacellerVersion methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:25'!
versions
	^#()! !

!GTMetacellerVersion methodsFor: 'tool' stamp: 'DiegoLont 4/25/2013 09:16'!
wrapperFor: aSpec
	(self isProject: aSpec) ifTrue: [  ^GTMetacellerProjectReference on: self spec: aSpec ].
	(self isGroup: aSpec) ifTrue: [  ^GTMetacellerGroup on: self spec: aSpec ].
	(self isPackage: aSpec) ifTrue: [ ^GTMetacellerPackage on: self spec: aSpec ].
	^aSpec
	! !

Object subclass: #GTPlatformDescription
	instanceVariableNames: 'symbol parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTPlatformDescription class
	instanceVariableNames: 'cached'!

GTPlatformDescription class
	instanceVariableNames: 'cached'!

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:54'!
allSymbols
	^self cached keys! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:54'!
buildOnSymbol: aSymbol
	| symbol |
	symbol := aSymbol asLowercase asSymbol.
	symbol = #'common' ifTrue: [ ^self on: nil symbol: symbol ].
	(#( #'gemstone' #'squeakcommon' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #common) symbol: symbol ].
	(#( #'pharo' #'squeak' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #squeakcommon) symbol: symbol ].
	(#( #'pharo1.x' #'pharo2.x' #'pharo3.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #pharo) symbol: symbol ].
	(#( #'pharo1.0.x' #'pharo1.1.x' #'pharo1.2.x' #'pharo1.3.x' #'pharo1.4.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #'pharo1.x') symbol: symbol ].
	(#( #'gs2.x' #'gs3.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #'gemstone') symbol: symbol ].
	(#( #'gs2.3.x' #'gs2.4.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #'gs2.x') symbol: symbol ].
	(#( #'gs3.0.x' #'gs3.1.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #'gs3.x') symbol: symbol ].
	" if this is reached, we need to specify more symbols in the hierarchie "
	^self on: nil symbol: aSymbol! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:52'!
cached
	^cached ifNil: [ cached := Dictionary new ]! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 11:35'!
on: aParent symbol: aSymbol
	^self basicNew
		initialize: aParent symbol: aSymbol;
		yourself! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:52'!
onSymbol: aSymbol
	| symbol |
	symbol := aSymbol asLowercase asSymbol.
	^self cached at: symbol ifAbsentPut: [ self buildOnSymbol: symbol ]! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:52'!
resetCache
	cached := nil! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:37'!
attributes
	^self attributesWith: OrderedCollection new! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:37'!
attributesWith: aCollection
	self parent ifNotNil: [ self parent attributesWith: aCollection ].
	^aCollection
		add: self symbol;
		yourself! !

!GTPlatformDescription methodsFor: 'testing' stamp: 'DiegoLont 9/17/2013 09:26'!
hasSymbol: aSymbol
	^(symbol compare: aSymbol caseSensitive: false) = 2! !

!GTPlatformDescription methodsFor: 'initialization' stamp: 'DiegoLont 9/16/2013 11:36'!
initialize: aParent symbol: aSymbol
	self initialize.
	parent := aParent.
	symbol := aSymbol! !

!GTPlatformDescription methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 14:07'!
isParent: aPlatformDescription 
	aPlatformDescription ifNil: [ ^false ].
	aPlatformDescription parent = self ifTrue: [ ^true ].
	^self isParent: aPlatformDescription parent! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:35'!
parent
	^ parent! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:58'!
printOn: aStream
	self symbol printOn: aStream! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:35'!
symbol
	^ symbol! !
GTMetacelloPlatform initialize!
